package monoproj;
/**************************************************************************************
Project name : Polygonal approximation applet
Written by  : Yousef Farasat
Version : 1.0
Date: April 2002

Updated by : Yueyun Shu
Date: April 2004

Open to public use
No guarantees provided with the program

Known bugs :


*****************************************************************************************/




import java.awt.*;
import java.applet.Applet;
import java.util.*;


public class Polyline {

 Point pt[];
 int size;
 static int count = 0;
 Random Poly = new Random();

 static double PI = 3.14159265358979323846264;
 static int projLength = 800;
 double angle[];
 static boolean computed;

 public Polyline(int pts) {
  size = pts;
  pt = new Point[size];

  for (int i = 0; i < size; i++) {
      pt[i] = new Point();
   }
  pt[0].parent = -1;
  for ( int i = 1; i < size; i++) {
      pt[i].parent = i - 1;
  }
  
  angle = new double[4];
  for(int i=0; i<4; i++) angle[i] = -1000;
  computed = false;
 }

 public void random (int a) {
    for ( count = 0;  count < a ; count++) {
    pt[count].x_coord = Math.abs(Poly.nextInt()% 400) + 100;
    pt[count].y_coord = Math.abs(Poly.nextInt()% 400) + 100;
    pt[count].parent = count - 1;
    pt[count].distance = 0;
    }

    //for (int i = 0 ;  i < a ; i++) {
    //pt[i].y_coord = Math.abs(Poly.nextInt()% 400) + 100;
    //}
 }

 public void insert(int x, int y) {
    pt[count].x_coord = x;
    pt[count].y_coord = y;
    pt[count].parent = count-1;
    pt[count].distance = 0;
    count++;
 }


 public int distance (int x1 , int y1 , int x2, int y2, int x3, int y3, int error)  {

 /**********************************************************************************
   Slope of the line between x1 and x2 and the line perpenticular to it.

  *********************************************************************************/

 double slope1 = ((((double)y2)- ((double)y1))/(((double)x2) - ((double)(x1))));
 double slope2 =  -1/slope1;


 /**********************************************************************************
 Delta_x and Delta_y to find the four corners of the rectangle in which the points can lay

  *********************************************************************************/

 double delta_x = Math.sqrt((error * error) / (( slope2 * slope2) + 1 ));
 double delta_y = slope2 * delta_x;

 int x_min = Math.min(x1,x2);
 int y_min = Math.min(y1,y2);

 int x_max = Math.max(x1,x2);
 int y_max = Math.max(y1,y2);

 int ydiff = (y2 - y1);
 int xdiff = (x2 - x1);

 int x13 = (x3-x1);
 int y13 =(y3-y1);

 int x23 = (x3-x2);
 int y23 =(y3-y2);


 double dist_x13 =  Math.sqrt(((x13)*(x13))+ ((y13)*(y13)));
 double dist_x23 =  Math.sqrt(((x23)*(x23))+ ((y23)*(y23)));


 double rightupper_x, rightupper_y;
 double leftlower_x, leftlower_y;

 if ((dist_x13 == 0) || dist_x23 == 0 ) return 1;
 if ( (dist_x13 <= error) || dist_x23 <= error ) return 1;

 if (ydiff == 0) {
    if ( Math.abs(x13) + Math.abs(x23) == Math.abs(xdiff)) {
      if ( Math.abs(y13) <= error ) return 1;
      else return 0;
    }
    else return 0;
   }

 if (xdiff == 0) {
   if ( Math.abs(y13) + Math.abs(y23) == Math.abs(ydiff)) {
      if ( Math.abs(x13) <= error ) return 1;
      else return 0;
   }
   else return 0;
 }

  if (slope1 > 0) {
        leftlower_x = x_min - delta_x;
        leftlower_y = y_min - delta_y;
        rightupper_x = x_max + delta_x;
        rightupper_y = y_max + delta_y;

        double xlower3 = x3 - leftlower_x;
        double ylower3 = y3 - leftlower_y;

        double xupper3 = x3 - rightupper_x;
        double yupper3 = y3 - rightupper_y;

   if ( x1 < x2) {
        double det1 = (xdiff * ylower3)-(ydiff * xlower3);
        double det2 = (((2*delta_x)*ylower3) - ((2*delta_y)*xlower3));
        double det3 = (-xdiff * yupper3)-(-ydiff * xupper3);
        double det4 =  (((-2*delta_x)*yupper3) - ((-2*delta_y)*xupper3));

       if ( det1 <= 0 && det2 >= 0 && det3 <=0 && det4 >= 0 ) return 1;
       else return 0;
      }

     if ( x1 > x2) {
        double det1 = (-xdiff * ylower3)-(-ydiff * xlower3);
        double det2 = (((2*delta_x)*ylower3) - ((2*delta_y)*xlower3));
        double det3 = (xdiff * yupper3)-(ydiff * xupper3);
        double det4 =  (((-2*delta_x)*yupper3) - ((-2*delta_y)*xupper3));

       if ( det1 <= 0 && det2 >= 0 && det3 <=0 && det4 >= 0 ) return 1;
       else return 0;
      }
    }

  if (slope1 < 0 ) {
        leftlower_x = x_min + delta_x;
        leftlower_y = y_max + delta_y;
        rightupper_x = x_max - delta_x;
        rightupper_y = y_min - delta_y;

        double xlower3 = x3 - leftlower_x;
        double ylower3 = y3 - leftlower_y;

        double xupper3 = x3 - rightupper_x;
        double yupper3 = y3 - rightupper_y;

     if  (x1 < x2)  {
        double det1 = (xdiff * ylower3)-(ydiff * xlower3);
        double det2 = (((-2*delta_x)*ylower3) - ((-2*delta_y)*xlower3));
        double det3 = (-xdiff * yupper3)-(-ydiff * xupper3);
        double det4 =  (((2*delta_x)*yupper3) - ((2*delta_y)*xupper3));

        if ( det1 <= 0 && det2 >= 0 && det3 <=0 && det4 >= 0 ) return 1;
        else return 0;
       }

      if  (x1 > x2)  {
        double det1 = (-xdiff * ylower3)-(-ydiff * xlower3);
        double det2 = (((-2*delta_x)*ylower3) - ((-2*delta_y)*xlower3));
        double det3 = (xdiff * yupper3)-(ydiff * xupper3);
        double det4 =  (((2*delta_x)*yupper3) - ((2*delta_y)*xupper3));

        if ( det1 <= 0 && det2 >= 0 && det3 <=0 && det4 >= 0 ) return 1;
        else return 0;
       }
   }
   return 0;
  }

  public void Shortest_distance (Polyline p, int error, int a) {
   int b;
   for ( int i = 0;  i <= a; i++ ) {
        for (int j = i + 1 ; j <= a; j++) {
              b = 0;
            for (int k = i + 1;  k < j ; k ++) {

                b = b + distance(p.pt[i].x_coord, p.pt[i].y_coord, p.pt[j].x_coord, p.pt[j].y_coord,p.pt[k].x_coord, p.pt[k].y_coord, error);

                 if ( b == j - i - 1 ) {
                   if ( p.pt[j].distance < b) {
                        p.pt[j].distance = b;
                        p.pt[j].parent = i;
                        }
                    }
              }
          }
      }
  }

  public void draw_approx (Polyline p, Graphics page, int a ) {
      page.setColor(Color.red);
      if (p.pt[a].parent == -1) {
        page.drawLine(p.pt[a].x_coord,  p.pt[a].y_coord, p.pt[0].x_coord, p.pt[0].y_coord);
      }
      else {
        page.drawLine(p.pt[a].x_coord,  p.pt[a].y_coord, p.pt[pt[a].parent].x_coord, p.pt[pt[a].parent].y_coord);
        draw_approx (p,page, p.pt[a].parent);
      }
   }

   // A half plane is formed by the origin point O and an oriented line sengment [P1,P2] as the normal. 
   // The plane is on the normal side. i.e. H+ = { x | [O,x] dot [P1,P2] > 0 }
   // All of the half planes intersect on the origin O, so a half plane can be described by a range of angle or two angles.
   // the range is PI, for example, (0,PI), (PI/4, PI*5/4)
   // Because angles have a period of 2*PI, we have to partition the range to two parts about 2*PI if it includes 2*PI, 
   // so that we have all the angles in (0, 2*PI), and make linear comparison possible.

  public void intersect (int a) {
      double theta, ta[];
      double dx = pt[a+1].x_coord - pt[a].x_coord;
      double dy = pt[a].y_coord - pt[a+1].y_coord;
      if(dx == 0) theta = PI/2;
      else theta = Math.atan(Math.abs(dy)/Math.abs(dx));
      if(dx<0 && dy>=0) theta = PI - theta;
      if(dx<=0 && dy<0) theta = PI + theta;
      if(dx>0 && dy<0) theta = 2*PI - theta;
      
      ta = new double[4];
      if(theta>=PI/2 && theta<=1.5*PI) 
      {
      	ta[0] = theta - PI/2;	// start angle of part 1
      	ta[1] = theta + PI/2;	// end angle of part 1
      	ta[2] = -1000;			// start angle of part 2, -1000 means no actual value
      	ta[3] = -1000;			// end angle of part 2, -1000 means no actual value
      }

      if(theta < PI/2) 
      {
      	ta[0] = 0;				// start angle of part 1
      	ta[1] = theta + PI/2;	// end angle of part 1
      	ta[2] = theta + 1.5*PI;	// start angle of part 2
      	ta[3] = 2*PI;			// end angle of part 2
      }

      if(theta > 1.5*PI) 
      {
      	ta[0] = 0;				// start angle of part 1
      	ta[1] = theta - 1.5*PI;	// end angle of part 1
      	ta[2] = theta - PI/2;	// start angle of part 2
      	ta[3] = 2*PI;			// end angle of part 2
      }

      // compute intersection of two half planes
      if (a == 0) {
        for(int i=0; i<4; i++) angle[i] = ta[i];
      }
      else {
	    boolean intersection1 = false;
	    boolean intersection2 = false;
        if(ta[0]>angle[1] || ta[1]<angle[0]) {
            //angle[0] = -1000;
            //angle[1] = -1000;
        }
        else {
        	if(ta[0] > angle[0]) angle[0] = ta[0];
        	if(ta[1] < angle[1]) angle[1] = ta[1];
        	intersection1 = true;
        }
        if(!intersection1 && angle[2]!=-1000) 
	        if(ta[0]>angle[3] || ta[1]<angle[2]) {
    	        //angle[2] = -1000;
        	    //angle[3] = -1000;
        	}
        	else {
        		if(ta[0] > angle[2]) angle[2] = ta[0];
        		if(ta[1] < angle[3]) angle[3] = ta[1];
        		intersection2 = true;
        	}

	    if(ta[2] != -1000) {
        if(!intersection1 && angle[0]!=-1000) 
        	if(ta[2]>angle[1] || ta[3]<angle[0]) {
            	//angle[0] = -1000;
            	//angle[1] = -1000;
        	}
        	else {
        		if(ta[2] > angle[0]) angle[0] = ta[2];
        		if(ta[3] < angle[1]) angle[1] = ta[3];
        		intersection1 = true;
        	}
        if(!intersection2 && angle[2]!=-1000) 
	        if(ta[2]>angle[3] || ta[3]<angle[2]) {
    	        //angle[2] = -1000;
        	    //angle[3] = -1000;
        	}
        	else {
        		if(ta[2] > angle[2]) angle[2] = ta[2];
        		if(ta[3] < angle[3]) angle[3] = ta[3];
        		intersection2 = true;
        	}
        }

	    if(!intersection1) {
            angle[0] = -1000;
            angle[1] = -1000;
        }
	    if(!intersection2) {
            angle[2] = -1000;
            angle[3] = -1000;
        }
      }
  	  //System.out.println(a+": ("+pt[a].x_coord+","+pt[a].y_coord+")"+",("+pt[a+1].x_coord+","+pt[a+1].y_coord+"),"+"("+dx+","+dy+"),"+theta+"   "+ta[0]+", "+ta[1]+", "+ta[2]+", "+ta[3]+"   angles: "+angle[0]+", "+angle[1]+", "+angle[2]+", "+angle[3]);
   }

  public void find_intersection () {
  	  if(computed) return;
      for(int i=0; i<count-1; i++){
      	intersect(i);
      	if(angle[0]==-1000 && angle[2]==-1000) break;
      }
  	  computed = true;
  }

  private java.awt.Point getClosestPoint(java.awt.Point pt1, java.awt.Point pt2, java.awt.Point p) {
	  double u = ((p.x-pt1.x)*(pt2.x-pt1.x)+(p.y-pt1.y)*(pt2.y-pt1.y))/(sqr(pt2.x-pt1.x)+sqr(pt2.y-pt1.y));
	  if (u > 1.0) return (java.awt.Point)pt2.clone();
	  else 
	  	if (u <= 0.0) return (java.awt.Point)pt1.clone();
		else return new java.awt.Point((int)(pt2.x*u+pt1.x*(1.0-u)+0.5), (int)(pt2.y*u+pt1.y*(1.0-u)+0.5));
  }

  private double sqr(double x) {
	  return x*x;
  }

  public void draw_a_projection(Graphics page) {
	  page.setColor(Color.red);
	  if(count <= 0) {	// no input points
  	  	page.drawString("The chain is null, please input points!",100,100);
  	  	return;
  	  }
  	  if(!computed) find_intersection();
  	  //System.out.println(angle[0]+", "+angle[1]+", "+angle[2]+", "+angle[3]);
  	  if(angle[0]==-1000 && angle[2]==-1000) {	// intersection area is null
  	  	page.drawString("The chain is not monotonic!",100,100);
  	  	return;
  	  }
	  double mid;
	  if(angle[0] != -1000) mid = (angle[0] + angle[1]) / 2;	// bisector of part 1
	  else mid = (angle[2] + angle[3]) / 2;	// bisector of part 2
	  java.awt.Point pt1,pt2,p,tp;

	  // draw a monotonic projection line
	  pt1 = new java.awt.Point(pt[0].x_coord, pt[0].y_coord);
	  int x1 = pt1.x + (int)(projLength * Math.cos(mid));
	  int y1 = pt1.y - (int)(projLength*Math.sin(mid));
	  //System.out.println(mid+", ("+x1+", "+y1+")");
	  pt2 = new java.awt.Point(x1, y1);
	  page.drawLine(pt1.x, pt1.y, pt2.x, pt2.y);
	  
	  // draw a projection line for each vertex
	  page.setColor(Color.blue);
	  p = new java.awt.Point();
	  for(int i=1; i<count; i++) {
	  	p.setLocation(pt[i].x_coord, pt[i].y_coord);
	  	tp = getClosestPoint(pt1,pt2,p);
	  	page.drawLine(p.x, p.y, tp.x, tp.y);
	  }
  }

  public void draw_monotonic_area(Graphics page) {
	  page.setColor(Color.orange);
	  if(count <= 0) {	// no input points
  	  	page.drawString("The chain is null, please input points!",100,100);
  	  	return;
  	  }
  	  if(!computed) find_intersection();
  	  if(angle[0]==-1000 && angle[2]==-1000) {	// intersection area is null
  	  	page.drawString("The chain is not monotonic!",100,100);
  	  	return;
  	  }
	  if(angle[0] != -1000)
	  	page.fillArc(pt[0].x_coord-100, pt[0].y_coord-100, 200, 200, (int)(angle[0]*180/PI), (int)((angle[1]-angle[0])*180/PI));	
	  if(angle[2] != -1000)
	  	page.fillArc(pt[0].x_coord-100, pt[0].y_coord-100, 200, 200, (int)(angle[2]*180/PI), (int)((angle[3]-angle[2])*180/PI));	
  }

}
