package monoproj;


/**************************************************************************************
Project name : Polygonal approximation applet
Written by  : Yousef Farasat
Version : 1.0
Date: April 2002

Updated by : Yueyun Shu
Date: April 2004

Open to public use
No guarantees provided with the program

Known bugs :


*****************************************************************************************/

import java.awt.*;
import java.applet.Applet;
import java.util.*;
import java.awt.event.*;

public class Test extends Applet {
  boolean isStandalone = false;
  Polyline polyline;
  BorderLayout borderLayout1 = new BorderLayout();
  DrawArea darea;
  Panel panel2 = new Panel();
  FlowLayout flowLayout1 = new FlowLayout();
  Button clear = new Button();
  Button calc = new Button();
  Button area = new Button();
  Button rand = new Button ();
  TextField Random = new TextField(2);
  //Label error = new Label ( "Error : ");
  //Label error_value = new Label ("O");
  //Scrollbar bar = new Scrollbar(Scrollbar.VERTICAL,0,10,0,600);

  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public Test() {
  }

  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void paint(Graphics page) {

  }

  //Component initialization
  private void jbInit() throws Exception {
    polyline = new Polyline(300);
    darea = new DrawArea(polyline);
    this.setLayout(borderLayout1);
    panel2.setLayout(flowLayout1);
    clear.setLabel("Clear");
    calc.setLabel("Draw a Projection");
    area.setLabel("Draw Monotonic Area");
    rand.setLabel("Random");

    /* Action listener, adds a point to polyline */
    darea.addMouseListener(new MouseListener() {
      public void mouseClicked(MouseEvent e) {
        polyline.insert(e.getX(),e.getY());
        darea.repaint();
      }
      public void mousePressed(MouseEvent e) {}
      public void mouseReleased(MouseEvent e) {}
      public void mouseExited(MouseEvent e) {}
      public void mouseEntered(MouseEvent e) {}
    });

    calc.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
/*
        for(int i = 0; i < polyline.count;i++) {
          polyline.pt[i].distance = 0;
          polyline.pt[i].parent = i-1;
        }
        polyline.Shortest_distance(polyline,bar.getValue(),polyline.count-1);
        darea.approx = true;
*/
        polyline.find_intersection();
        darea.aproj = true;
        darea.repaint();
      }
    });

    area.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        polyline.find_intersection();
        darea.area = true;
        darea.repaint();
      }
    });

    clear.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        polyline.count = 0;
        polyline.computed = false;
        darea.approx = false;
        darea.aproj = false;
        darea.area = false;
        darea.repaint();
      }
    });

    rand.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
        polyline.count = 0;
        polyline.computed = false;
        darea.repaint();
        polyline.random(Integer.parseInt(Random.getText()));
        darea.approx = false;
        darea.aproj = false;
        darea.area = false;
        darea.repaint();
       }
    }
    );
/*
    bar.addAdjustmentListener(new AdjustmentListener() {
      public void adjustmentValueChanged(AdjustmentEvent e) {
        for(int i = 0; i < polyline.count;i++) {
          polyline.pt[i].distance = 0;
          polyline.pt[i].parent = i-1;
        }
        error_value.setText(Integer.toString(bar.getValue()));
        polyline.Shortest_distance(polyline,bar.getValue(),polyline.count-1);
        darea.approx = true;
        darea.repaint();
      }
    });
*/
    this.add(darea, BorderLayout.CENTER);
    this.add(panel2,  BorderLayout.SOUTH);
    panel2.add(calc, null);
    panel2.add(area, null);
    panel2.add(Random, null);
    panel2.add(rand, null);
    panel2.add(clear, null);
    //panel2.add(error, null);
    //panel2.add(error_value, null);
    //this.add(bar, BorderLayout.WEST);
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }
}

class DrawArea extends Canvas {

  Polyline polyline;
  boolean approx = false;
  boolean aproj = false;
  boolean area = false;

  public DrawArea(Polyline polyline) {
    this.polyline = polyline;
  }

  public void init() {
  }

  public void paint(Graphics page) {
    for(int i = 0; i < polyline.count; i++) {
      draw(polyline.pt[i],page,i);
    }
    //if(approx == true) polyline.draw_approx(polyline,page,polyline.count-1);
    if(aproj == true) polyline.draw_a_projection(page);
    if(area == true) polyline.draw_monotonic_area(page);
  }

  public void draw(Point p, Graphics page, int i) {
    page.fillOval(p.x_coord-2,p.y_coord-2,5,5);
    String s = "";
    s += i;
    page.drawString(s,p.x_coord+2,p.y_coord+2);
    if(i > 0) { drawLine(i,page); }
  }

  public void drawLine(int i, Graphics page) {
    Point p1 = polyline.pt[i];
    Point p2 = polyline.pt[i-1];
    page.drawLine(p1.x_coord,p1.y_coord,p2.x_coord,p2.y_coord);
  }

}
